Index: trunk/NEMO/OPA_SRC/TRA/traadv_cen2.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/traadv_cen2.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRA/traadv_cen2.F90	(revision 503)
@@ -4,10 +4,10 @@
    !! Ocean active tracers:  horizontal & vertical advective trend
    !!==============================================================================
-   !! History :
-   !!   8.2  !  01-08  (G. Madec, E. Durand)  trahad+trazad = traadv 
-   !!   8.5  !  02-06  (G. Madec)  F90: Free form and module
-   !!   9.0  !  04-08  (C. Talandier) New trends organization
-   !!    "   !  05-11  (V. Garnier) Surface pressure gradient organization
-   !!    "   !  06-04  (R. Benshila, G. Madec) Step reorganization
+   !! History :  8.2  !  01-08  (G. Madec, E. Durand)  trahad+trazad = traadv 
+   !!            8.5  !  02-06  (G. Madec)  F90: Free form and module
+   !!            9.0  !  05-11  (V. Garnier) Surface pressure gradient organization
+   !!            " "  !  06-04  (R. Benshila, G. Madec) Step reorganization
+   !!----------------------------------------------------------------------
+
    !!----------------------------------------------------------------------
    !!   tra_adv_cen2 : update the tracer trend with the horizontal and
@@ -15,5 +15,4 @@
    !!                  centered scheme. (k-j-i loops)
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and active tracers
    USE dom_oce         ! ocean space and time domain
@@ -33,6 +32,7 @@
    PRIVATE
 
-   !! * Accessibility
-   PUBLIC tra_adv_cen2    ! routine called by step.F90
+   PUBLIC   tra_adv_cen2   ! routine called by step.F90
+
+   REAL(wp), DIMENSION(jpi,jpj) ::   btr2   ! inverse of T-point surface [1/(e1t*e2t)]
 
    !! * Substitutions
@@ -42,5 +42,5 @@
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
    !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -86,6 +86,4 @@
       !!         zta+tn*divn=1/(e1t*e2t*e3t) { mi-1( e2u*e3u  un  di[tn] )
       !!                                      +mj-1( e1v*e3v  vn  mj[tn] )  }
-      !!         C A U T I O N : the trend saved is the centered trend only.
-      !!      It doesn't take into account the upstream part of the scheme.
       !!         NB:in z-coordinate - full step (ln_zco=T) e3u=e3v=e3t, so
       !!      they vanish from the expression of the flux and divergence.
@@ -110,22 +108,15 @@
       !!
       !! ** Action :  - update (ta,sa) with the now advective tracer trends
-      !!              - save trends in (ttrdh,ttrd,strdhi,strd) ('key_trdtra')
-      !!
+      !!              - save trends in (ztrdt,ztrds) ('key_trdtra')
       !!----------------------------------------------------------------------
-      !! * Modules used
-      USE oce                , zwx => ua,  &  ! use ua as workspace
-         &                     zwy => va      ! use va as workspace
-
-      !! * Arguments
-      INTEGER , INTENT( in ) ::   kt          ! ocean time-step index
-      REAL(wp), INTENT( in ), DIMENSION(jpi,jpj,jpk) ::   &
-         pun, pvn, pwn                        ! now ocean velocity fields
- 
-      !! * Local save
-      REAL(wp), DIMENSION(jpi,jpj), SAVE ::   &
-         zbtr2
- 
-      !! * Local declarations
-      INTEGER  ::   ji, jj, jk                 ! dummy loop indices
+      USE oce, ONLY :   zwx => ua   ! use ua as workspace
+      USE oce, ONLY :   zwy => va   ! use va as workspace
+      !!
+      INTEGER , INTENT(in)                         ::   kt    ! ocean time-step index
+      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pun   ! ocean velocity u-component
+      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pvn   ! ocean velocity v-component
+      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pwn   ! ocean velocity w-component
+      !!
+      INTEGER  ::   ji, jj, jk                           ! dummy loop indices
       REAL(wp) ::                           &
          zbtr, zta, zsa, zfui, zfvj,        &  ! temporary scalars
@@ -135,8 +126,8 @@
          zcofk, zupst, zupss, zcent,        &  !    "         "
          zcens, zfp_w, zfm_w,               &  !    "         "
-         zcenut, zcenvt, zcenus, zcenvs        !    "         "
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &
-         zwz, zww, zind,                    &  ! temporary workspace arrays
-         ztdta, ztdsa                          !    "         "
+         zcenut, zcenvt, zcenus, zcenvs,    &  !    "         "
+         z_hdivn_x, z_hdivn_y, z_hdivn
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zwz, ztrdt, zind   ! 3D workspace 
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zww, ztrds         !  "      "
       !!----------------------------------------------------------------------
 
@@ -146,18 +137,10 @@
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~   Vector optimization case'
          IF(lwp) WRITE(numout,*)
-   
-         zbtr2(:,:) = 1. / ( e1t(:,:) * e2t(:,:) )
-      ENDIF
-
-      ! Save ta and sa trends
-      IF( l_trdtra )   THEN
-         ztdta(:,:,:) = ta(:,:,:) 
-         ztdsa(:,:,:) = sa(:,:,:) 
-         l_adv = 'ce2'
+         ! 
+         btr2(:,:) = 1. / ( e1t(:,:) * e2t(:,:) )
       ENDIF
 
       ! Upstream / centered scheme indicator
       ! ------------------------------------
- 
       DO jk = 1, jpk
          DO jj = 1, jpj
@@ -176,10 +159,6 @@
 
 
-      ! I. Horizontal advective fluxes
-      ! ------------------------------
-
-      ! 1. Second order centered tracer flux at u and v-points
-      ! -------------------------------------------------------
-
+      !  Horizontal advective fluxes
+      ! -----------------------------
       !                                                ! ===============
       DO jk = 1, jpkm1                                 ! Horizontal slab
@@ -220,13 +199,12 @@
          END DO
 
-         ! 2. Tracer flux divergence at t-point added to the general trend
-         ! ---------------------------------------------------------------
-
+         !  Tracer flux divergence at t-point added to the general trend
+         ! --------------------------------------------------------------
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
 #if defined key_zco
-               zbtr = zbtr2(ji,jj)
-#else
-               zbtr = zbtr2(ji,jj) / fse3t(ji,jj,jk)
+               zbtr = btr2(ji,jj)
+#else
+               zbtr = btr2(ji,jj) / fse3t(ji,jj,jk)
 #endif
                ! horizontal advective trends
@@ -244,20 +222,56 @@
       !                                                ! ===============
 
-      ! 3. Save the horizontal advective trends for diagnostic
-      ! ------------------------------------------------------
-      IF( l_trdtra )   THEN
-         ! Recompute the hoizontal advection zta & zsa trends computed 
-         ! at the step 2. above in making the difference between the new 
-         ! trends and the previous one ta()/sa - ztdta()/ztdsa() and add
-         ! the term tn()/sn()*hdivn() to recover the Uh gradh(T/S) trends
-         ztdta(:,:,:) = ta(:,:,:) - ztdta(:,:,:) + tn(:,:,:) * hdivn(:,:,:) 
-         ztdsa(:,:,:) = sa(:,:,:) - ztdsa(:,:,:) + sn(:,:,:) * hdivn(:,:,:)
-
-         CALL trd_mod(ztdta, ztdsa, jpttdlad, 'TRA', kt)
-
-         ! Save the new ta and sa trends
-         ztdta(:,:,:) = ta(:,:,:) 
-         ztdsa(:,:,:) = sa(:,:,:) 
-
+      !  Save the horizontal advective trends for diagnostic
+      ! -----------------------------------------------------
+      IF( l_trdtra ) THEN
+         ! T/S ZONAL advection trends
+         ztrdt(:,:,:) = 0.e0   ;   ztrds(:,:,:) = 0.e0
+         !
+         DO jk = 1, jpkm1
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  !-- Compute zonal divergence by splitting hdivn (see divcur.F90)
+                  !   N.B. This computation is not valid along OBCs (if any)
+#if defined key_zco
+                  zbtr      = btr2(ji,jj) 
+                  z_hdivn_x = (  e2u(ji  ,jj) * pun(ji  ,jj,jk)                              &
+                     &         - e2u(ji-1,jj) * pun(ji-1,jj,jk) ) * zbtr
+#else
+                  zbtr      = btr2(ji,jj) / fse3t(ji,jj,jk)
+                  z_hdivn_x = (  e2u(ji  ,jj) * fse3u(ji  ,jj,jk) * pun(ji  ,jj,jk)          &
+                     &         - e2u(ji-1,jj) * fse3u(ji-1,jj,jk) * pun(ji-1,jj,jk) ) * zbtr
+#endif
+                  ztrdt(ji,jj,jk) = - zbtr * ( zwx(ji,jj,jk) - zwx(ji-1,jj,jk) ) + tn(ji,jj,jk) * z_hdivn_x
+                  ztrds(ji,jj,jk) = - zbtr * ( zww(ji,jj,jk) - zww(ji-1,jj,jk) ) + sn(ji,jj,jk) * z_hdivn_x
+               END DO
+            END DO
+         END DO
+         CALL trd_mod(ztrdt, ztrds, jptra_trd_xad, 'TRA', kt)
+         !
+         ! T/S MERIDIONAL advection trends
+         DO jk = 1, jpkm1
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  !-- Compute merid. divergence by splitting hdivn (see divcur.F90)
+                  !   N.B. This computation is not valid along OBCs (if any)
+#if defined key_zco
+                  zbtr      = btr2(ji,jj) 
+                  z_hdivn_y = (  e1v(ji,jj  ) * pvn(ji,jj  ,jk)                              &
+                     &         - e1v(ji,jj-1) * pvn(ji,jj-1,jk) ) * zbtr
+#else
+                  zbtr      = btr2(ji,jj) / fse3t(ji,jj,jk)
+                  z_hdivn_y = (  e1v(ji,  jj) * fse3v(ji,jj  ,jk) * pvn(ji,jj  ,jk)          &
+                     &         - e1v(ji,jj-1) * fse3v(ji,jj-1,jk) * pvn(ji,jj-1,jk) ) * zbtr
+#endif
+                  ztrdt(ji,jj,jk) = - zbtr * ( zwy(ji,jj,jk) - zwy(ji,jj-1,jk) ) + tn(ji,jj,jk) * z_hdivn_y          
+                  ztrds(ji,jj,jk) = - zbtr * ( zwz(ji,jj,jk) - zwz(ji,jj-1,jk) ) + sn(ji,jj,jk) * z_hdivn_y
+               END DO
+            END DO
+         END DO
+         CALL trd_mod(ztrdt, ztrds, jptra_trd_yad, 'TRA', kt)
+         !
+         ! Save the horizontal up-to-date ta/sa trends
+         ztrdt(:,:,:) = ta(:,:,:) 
+         ztrds(:,:,:) = sa(:,:,:)
       ENDIF
 
@@ -265,5 +279,7 @@
          &                       tab3d_2=sa, clinfo2=            ' Sa: ', mask2=tmask, clinfo3='tra' )
 
-      ! "zonal" mean advective heat and salt transport
+      ! 4. "zonal" mean advective heat and salt transport 
+      ! -------------------------------------------------
+
       IF( ln_diaptr .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN
          IF( lk_zco ) THEN
@@ -299,7 +315,5 @@
       ! 1. Vertical advective fluxes
       ! ----------------------------
-
       ! Second order centered tracer flux at w-point
-
       DO jk = 2, jpk
          DO jj = 2, jpjm1
@@ -324,8 +338,6 @@
       END DO
 
-
       ! 2. Tracer flux divergence at t-point added to the general trend
       ! -------------------------
-  
       DO jk = 1, jpkm1
          DO jj = 2, jpjm1
@@ -347,16 +359,31 @@
          ! Recompute the vertical advection zta & zsa trends computed 
          ! at the step 2. above in making the difference between the new 
-         ! trends and the previous one: ta()/sa - ztdta()/ztdsa() and substract
+         ! trends and the previous one: ta()/sa - ztrdt()/ztrds() and substract
          ! the term tn()/sn()*hdivn() to recover the W gradz(T/S) trends
-         ztdta(:,:,:) = ta(:,:,:) - ztdta(:,:,:) - tn(:,:,:) * hdivn(:,:,:) 
-         ztdsa(:,:,:) = sa(:,:,:) - ztdsa(:,:,:) - sn(:,:,:) * hdivn(:,:,:)
-
-         CALL trd_mod(ztdta, ztdsa, jpttdzad, 'TRA', kt)
+
+         DO jk = 1, jpkm1
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+#if defined key_zco
+                  zbtr      = btr2(ji,jj) 
+                  z_hdivn_x = e2u(ji,jj)*pun(ji,jj,jk) - e2u(ji-1,jj)*pun(ji-1,jj,jk)
+                  z_hdivn_y = e1v(ji,jj)*pvn(ji,jj,jk) - e1v(ji,jj-1)*pvn(ji,jj-1,jk)
+#else
+                  zbtr      = btr2(ji,jj) / fse3t(ji,jj,jk)
+                  z_hdivn_x = e2u(ji,jj)*fse3u(ji,jj,jk)*pun(ji,jj,jk) - e2u(ji-1,jj)*fse3u(ji-1,jj,jk)*pun(ji-1,jj,jk)
+                  z_hdivn_y = e1v(ji,jj)*fse3v(ji,jj,jk)*pvn(ji,jj,jk) - e1v(ji,jj-1)*fse3v(ji,jj-1,jk)*pvn(ji,jj-1,jk)
+#endif
+                  z_hdivn   = (z_hdivn_x + z_hdivn_y) * zbtr
+                  ztrdt(ji,jj,jk) = ta(ji,jj,jk) - ztrdt(ji,jj,jk) - tn(ji,jj,jk) * z_hdivn 
+                  ztrds(ji,jj,jk) = sa(ji,jj,jk) - ztrds(ji,jj,jk) - sn(ji,jj,jk) * z_hdivn
+               END DO
+            END DO
+         END DO
+         CALL trd_mod(ztrdt, ztrds, jptra_trd_zad, 'TRA', kt)
       ENDIF
 
       IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' cen2 zad  - Ta: ', mask1=tmask, &
          &                       tab3d_2=sa, clinfo2=            ' Sa: ', mask2=tmask, clinfo3='tra' )
-
-
+      !
    END SUBROUTINE tra_adv_cen2
 
Index: trunk/NEMO/OPA_SRC/TRA/traadv_cen2_jki.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/traadv_cen2_jki.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRA/traadv_cen2_jki.F90	(revision 503)
@@ -4,10 +4,10 @@
    !! Ocean active tracers:  horizontal & vertical advective trend
    !!==============================================================================
-   !! History :
-   !!   8.2  !  01-08  (G. Madec, E. Durand)  trahad+trazad = traadv
-   !!   8.5  !  02-06  (G. Madec)  F90: Free form and module
-   !!   9.0  !  04-08  (C. Talandier) New trends organization
-   !!    "   !  05-11  (V. Garnier) Surface pressure gradient organization
-   !!    "   !  06-04  (R. Benshila, G. Madec) Step reorganization
+   !! History :  8.2  !  01-08  (G. Madec, E. Durand)  trahad+trazad = traadv
+   !!            8.5  !  02-06  (G. Madec)  F90: Free form and module
+   !!            9.0  !  05-11  (V. Garnier) Surface pressure gradient organization
+   !!            " "  !  06-04  (R. Benshila, G. Madec) Step reorganization
+   !!----------------------------------------------------------------------
+
    !!----------------------------------------------------------------------
    !!   tra_adv_cen2_jki : update the tracer trend with the horizontal and
@@ -16,5 +16,4 @@
    !!                  hor. adv., j-slab for vert. adv. (j-k-i loops)
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and active tracers
    USE dom_oce         ! ocean space and time domain
@@ -34,6 +33,7 @@
    PRIVATE
 
-   !! * Accessibility
-   PUBLIC tra_adv_cen2_jki    ! routine called by step.F90
+   PUBLIC   tra_adv_cen2_jki   ! routine called by step.F90
+
+   REAL(wp), DIMENSION(jpi,jpj) ::   btr2   ! inverse of T-point surface [1/(e1t*e2t)]
 
    !! * Substitutions
@@ -42,11 +42,9 @@
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LOCEAN-IPSL (2005)
+   !! $Header$ 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
 CONTAINS
-
-   !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
-   !!----------------------------------------------------------------------
 
    SUBROUTINE tra_adv_cen2_jki( kt, pun, pvn, pwn )
@@ -89,6 +87,4 @@
       !!         zta+tn*divn=1/(e1t*e2t*e3t) { mi-1( e2u*e3u  un  di[tn] )
       !!                                      +mj-1( e1v*e3v  vn  mj[tn] )  }
-      !!         C A U T I O N : the trend saved is the centered trend only.
-      !!      It doesn't take into account the upstream part of the scheme.
       !!         NB:in z-coordinate - full step (ln_zco=T) e3u=e3v=e3t, so 
       !!      they vanish from the expression of the flux and divergence.
@@ -113,22 +109,15 @@
       !!
       !! ** Action :  - update (ta,sa) with the now advective tracer trends
-      !!              - save trends in (ttrdh,ttrd,strdhi,strd) ('key_trdtra')
-      !!
+      !!              - save trends in (ztrdt,ztrds) ('key_trdtra')
       !!----------------------------------------------------------------------
-      !! * Modules used
-      USE oce              , zwx => ua,    &  ! use ua as workspace
-         &                   zwy => va        ! use va as workspace
-
-      !! * Arguments
-      INTEGER , INTENT( in ) ::   kt          ! ocean time-step index
-      REAL(wp), INTENT( in ), DIMENSION(jpi,jpj,jpk) ::   &
-         pun, pvn, pwn                        ! now ocean velocity fields
-
-      !! * Local save
-      REAL(wp), DIMENSION(jpi,jpj), SAVE ::   &
-         zbtr2
-
-      !! * Local declarations
-      INTEGER  ::   ji, jj, jk                 ! dummy loop indices
+      USE oce, ONLY :   zwx => ua   ! use ua as workspace
+      USE oce, ONLY :   zwy => va   ! use va as workspace
+      !!
+      INTEGER , INTENT(in)                         ::   kt    ! ocean time-step index
+      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pun   ! ocean velocity u-component
+      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pvn   ! ocean velocity v-component
+      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pwn   ! ocean velocity w-component
+      !!
+      INTEGER  ::   ji, jj, jk                           ! dummy loop indices
       REAL(wp) ::                           &
          zbtr, zta, zsa, zfui, zfvj,        &  ! temporary scalars
@@ -138,8 +127,8 @@
          zcofk, zupst, zupss, zcent,        &  !    "         "
          zcens, zfp_w, zfm_w,               &  !    "         "
-         zcenut, zcenvt, zcenus, zcenvs        !    "         "
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &
-         zwz, zww, zind,                    &  ! temporary workspace arrays
-         ztdta, ztdsa                          !    "         "
+         zcenut, zcenvt, zcenus, zcenvs,    &  !    "         "
+         z_hdivn_x, z_hdivn_y, z_hdivn
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zwz, ztrdt, zind   ! 3D workspace 
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zww, ztrds         !  "      "
       !!----------------------------------------------------------------------
 
@@ -149,13 +138,6 @@
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~   Auto-tasking case'
          IF(lwp) WRITE(numout,*)
-         
-         zbtr2(:,:) = 1. / ( e1t(:,:) * e2t(:,:) )
-      ENDIF
-
-      ! Save ta and sa trends
-      IF( l_trdtra )   THEN
-         ztdta(:,:,:) = ta(:,:,:) 
-         ztdsa(:,:,:) = sa(:,:,:) 
-         l_adv = 'ce2'
+         !
+         btr2(:,:) = 1. / ( e1t(:,:) * e2t(:,:) )
       ENDIF
 
@@ -165,7 +147,6 @@
       DO jk = 1, jpkm1                                 ! Horizontal slab
          !                                             ! ===============
-
-         ! 0. Upstream / centered scheme indicator
-         ! ---------------------------------------
+         !  Upstream / centered scheme indicator
+         ! --------------------------------------
          DO jj = 1, jpj
             DO ji = 1, jpi
@@ -181,7 +162,6 @@
          END DO
 
-
-         ! I. Horizontal advective fluxes
-         ! ------------------------------
+         !  Horizontal advective fluxes
+         ! -----------------------------
          ! Second order centered tracer flux at u and v-points
          DO jj = 1, jpjm1
@@ -220,13 +200,11 @@
          END DO
 
-         ! 2. Tracer flux divergence at t-point added to the general trend
-         ! ---------------------------------------------------------------
-
+         ! Tracer flux divergence at t-point added to the general trend
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
 #if defined key_zco
-               zbtr = zbtr2(ji,jj) 
-#else
-               zbtr = zbtr2(ji,jj) / fse3t(ji,jj,jk)
+               zbtr = btr2(ji,jj) 
+#else
+               zbtr = btr2(ji,jj) / fse3t(ji,jj,jk)
 #endif
                ! horizontal advective trends
@@ -244,20 +222,59 @@
       !                                                ! ===============
 
-      ! 3. Save the horizontal advective trends for diagnostic
-      ! ------------------------------------------------------
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' cen2 had  - Ta: ', mask1=tmask,   &
+         &                       tab3d_2=sa, clinfo2=            ' Sa: ', mask2=tmask, clinfo3='tra' )
+
+      ! Save the horizontal advective trends for diagnostics
       IF( l_trdtra )   THEN
-         ! Recompute the hoizontal advection zta & zsa trends computed 
-         ! at the step 2. above in making the difference between the new 
-         ! trends and the previous one ta()/sa - ztdta()/ztdsa() and add
-         ! the term tn()/sn()*hdivn() to recover the Uh gradh(T/S) trends
-         ztdta(:,:,:) = ta(:,:,:) - ztdta(:,:,:) + tn(:,:,:) * hdivn(:,:,:) 
-         ztdsa(:,:,:) = sa(:,:,:) - ztdsa(:,:,:) + sn(:,:,:) * hdivn(:,:,:)
-
-         CALL trd_mod(ztdta, ztdsa, jpttdlad, 'TRA', kt)
-
-         ! Save the new ta and sa trends
-         ztdta(:,:,:) = ta(:,:,:) 
-         ztdsa(:,:,:) = sa(:,:,:) 
-
+         ztrdt(:,:,:) = 0.e0   ;   ztrds(:,:,:) = 0.e0
+         !
+         ! T/S ZONAL advection trends
+         DO jk = 1, jpkm1
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  !-- Compute zonal divergence by splitting hdivn (see divcur.F90)
+                  !   N.B. This computation is not valid along OBCs (if any)
+#if defined key_zco
+                  zbtr      = btr2(ji,jj) 
+                  z_hdivn_x = (  e2u(ji  ,jj) * pun(ji  ,jj,jk)                              &
+                     &         - e2u(ji-1,jj) * pun(ji-1,jj,jk) ) * zbtr
+#else
+                  zbtr      = btr2(ji,jj) / fse3t(ji,jj,jk)
+                  z_hdivn_x = (  e2u(ji  ,jj) * fse3u(ji  ,jj,jk) * pun(ji  ,jj,jk)          &
+                     &         - e2u(ji-1,jj) * fse3u(ji-1,jj,jk) * pun(ji-1,jj,jk) ) * zbtr
+#endif
+                  ztrdt(ji,jj,jk) = - zbtr * ( zwx(ji,jj,jk) - zwx(ji-1,jj,jk) ) + tn(ji,jj,jk) * z_hdivn_x
+                  ztrds(ji,jj,jk) = - zbtr * ( zww(ji,jj,jk) - zww(ji-1,jj,jk) ) + sn(ji,jj,jk) * z_hdivn_x
+               END DO
+            END DO
+         END DO
+         CALL trd_mod(ztrdt, ztrds, jptra_trd_xad, 'TRA', kt)
+         !
+         ! T/S MERIDIONAL advection trends
+         DO jk = 1, jpkm1
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  !-- Compute merid. divergence by splitting hdivn (see divcur.F90)
+                  !   N.B. This computation is not valid along OBCs (if any)
+#if defined key_zco
+                  zbtr      = btr2(ji,jj) 
+                  z_hdivn_y = (  e1v(ji,jj  ) * pvn(ji,jj  ,jk)                              &
+                     &         - e1v(ji,jj-1) * pvn(ji,jj-1,jk) ) * zbtr
+#else
+                  zbtr      = btr2(ji,jj) / fse3t(ji,jj,jk)
+                  z_hdivn_y = (  e1v(ji,  jj) * fse3v(ji,jj  ,jk) * pvn(ji,jj  ,jk)          &
+                     &         - e1v(ji,jj-1) * fse3v(ji,jj-1,jk) * pvn(ji,jj-1,jk) ) * zbtr
+#endif
+                  ztrdt(ji,jj,jk) = - zbtr * ( zwy(ji,jj,jk) - zwy(ji,jj-1,jk) ) + tn(ji,jj,jk) * z_hdivn_y          
+                  ztrds(ji,jj,jk) = - zbtr * ( zwz(ji,jj,jk) - zwz(ji,jj-1,jk) ) + sn(ji,jj,jk) * z_hdivn_y
+               END DO
+            END DO
+         END DO
+         CALL trd_mod(ztrdt, ztrds, jptra_trd_yad, 'TRA', kt)
+         !
+         ! Save the up-to-date ta and sa trends
+         ztrdt(:,:,:) = ta(:,:,:) 
+         ztrds(:,:,:) = sa(:,:,:)
+         !
       ENDIF
 
@@ -281,6 +298,6 @@
       ENDIF
 
-      ! II. Vertical advection
-      ! ----------------------
+      !  Vertical advection
+      ! --------------------
 !CDIR PARALLEL DO
 !$OMP PARALLEL DO
@@ -300,7 +317,5 @@
          ENDIF
          
-         ! 1. Vertical advective fluxes
-         ! ----------------------------
-         ! Second order centered tracer flux at w-point
+         ! Vertical advective fluxes at w-point
          DO jk = 2, jpk
             DO ji = 2, jpim1
@@ -323,6 +338,5 @@
          END DO
 
-         ! 2. Tracer flux divergence at t-point added to the general trend
-         ! -------------------------
+         ! Tracer flux divergence at t-point added to the general trend
          DO jk = 1, jpkm1
             DO ji = 2, jpim1
@@ -340,20 +354,36 @@
       !                                                ! ===============
 
-      ! 3. Save the vertical advective trends for diagnostic
-      ! ----------------------------------------------------
+      ! Save the vertical advective trends for diagnostic
       IF( l_trdtra )   THEN
          ! Recompute the vertical advection zta & zsa trends computed 
          ! at the step 2. above in making the difference between the new 
-         ! trends and the previous one: ta()/sa - ztdta()/ztdsa() and substract
+         ! trends and the previous one: ta()/sa - ztrdt()/ztrds() and substract
          ! the term tn()/sn()*hdivn() to recover the W gradz(T/S) trends
-         ztdta(:,:,:) = ta(:,:,:) - ztdta(:,:,:) - tn(:,:,:) * hdivn(:,:,:) 
-         ztdsa(:,:,:) = sa(:,:,:) - ztdsa(:,:,:) - sn(:,:,:) * hdivn(:,:,:)
-
-         CALL trd_mod(ztdta, ztdsa, jpttdzad, 'TRA', kt)
+         !
+         DO jk = 1, jpkm1
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+#if defined key_zco
+                  zbtr      = btr2(ji,jj) 
+                  z_hdivn_x = e2u(ji,jj)*pun(ji,jj,jk) - e2u(ji-1,jj)*pun(ji-1,jj,jk)
+                  z_hdivn_y = e1v(ji,jj)*pvn(ji,jj,jk) - e1v(ji,jj-1)*pvn(ji,jj-1,jk)
+#else
+                  zbtr      = btr2(ji,jj) / fse3t(ji,jj,jk)
+                  z_hdivn_x = e2u(ji,jj)*fse3u(ji,jj,jk)*pun(ji,jj,jk) - e2u(ji-1,jj)*fse3u(ji-1,jj,jk)*pun(ji-1,jj,jk)
+                  z_hdivn_y = e1v(ji,jj)*fse3v(ji,jj,jk)*pvn(ji,jj,jk) - e1v(ji,jj-1)*fse3v(ji,jj-1,jk)*pvn(ji,jj-1,jk)
+#endif
+                  z_hdivn   = (z_hdivn_x + z_hdivn_y) * zbtr
+                  ztrdt(ji,jj,jk) = ta(ji,jj,jk) - ztrdt(ji,jj,jk) - tn(ji,jj,jk) * z_hdivn 
+                  ztrds(ji,jj,jk) = sa(ji,jj,jk) - ztrds(ji,jj,jk) - sn(ji,jj,jk) * z_hdivn
+               END DO
+            END DO
+         END DO
+         CALL trd_mod(ztrdt, ztrds, jptra_trd_zad, 'TRA', kt)
+         !
       ENDIF
 
-      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' cen2 zad  - Ta: ', mask1=tmask, &
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' cen2 zad  - Ta: ', mask1=tmask,   &
          &                       tab3d_2=sa, clinfo2=            ' Sa: ', mask2=tmask, clinfo3='tra' )
-
+      !
    END SUBROUTINE tra_adv_cen2_jki
 
